SystemOrganization addCategory: #'SourceCity-Core'!

Object subclass: #AbstractCityComponent
	instanceVariableNames: 'name id dimension color position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!AbstractCityComponent commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ color! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color: anObject
	color := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension

	^ dimension! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension: anObject

	dimension := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
id

	^ id! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
id: anObject

	id := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/4/2012 14:50'!
initialize
	width:= 0.5.
	height:= 0.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/4/2012 13:09'!
name
	^name! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/4/2012 13:08'!
name: anObject
	name := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position

	^ position! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position: anObject

	position := anObject! !

AbstractCityComponent subclass: #Building
	instanceVariableNames: 'district'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building class methodsFor: 'instance creation' stamp: 'blo 7/5/2012 11:17'!
named: aName inDistrict: aDistrict dimension: a3Ddimension color: aColor

	^ self new 
		name: aName;
		dimension: a3Ddimension;
		district: aDistrict;
		color: aColor.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
district
	^ district! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 14:55'!
district: anObject
	district := anObject.
	self district add: self.! !

!Building methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:20'!
printOn: aStream

	district ifNotNil: [ aStream
					nextPutAll: district asString; 
					nextPutAll: ' -> '].
	name ifNotNil: [ aStream 
					nextPutAll: ' Building: '; 
					nextPutAll: self name].! !

AbstractCityComponent subclass: #City
	instanceVariableNames: 'districts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City class methodsFor: 'instance creation' stamp: 'blo 7/4/2012 15:16'!
named: aName
	^ self new 
		name: aName.
		! !

!City methodsFor: 'adding' stamp: 'blo 7/5/2012 12:33'!
add: aDistrict

	districts add: aDistrict.
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ Color r: 0.6 g: 0.6 b: 0.6! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts
	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'comparing' stamp: 'DouailleErwan 6/12/2012 10:22'!
hasDistrictNamed: aString

	^ districts anySatisfy: [ :each | each model name = aString ]! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:22'!
initialize

	super initialize.
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:20'!
printOn: aStream

	name ifNotNil: [ aStream 
					nextPutAll: ' City: '; 
					nextPutAll: self name].! !

AbstractCityComponent subclass: #District
	instanceVariableNames: 'buildings city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District class methodsFor: 'instance creation' stamp: 'blo 7/4/2012 14:52'!
named: aName inCity: aCity

	^ self new
		name: aName;
		city: aCity.! !

!District methodsFor: 'adding' stamp: 'blo 7/5/2012 12:34'!
add: aBuilding

	buildings add: aBuilding.
	^ aBuilding.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings
	^ buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings: anObject
	buildings := anObject! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
city
	^ city! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 14:54'!
city: anObject
	city := anObject.
	self city add: self.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:30'!
color
	^Color r: 0.8 g: 0.8 b:0.8! !

!District methodsFor: 'comparing' stamp: 'DouailleErwan 6/15/2012 12:38'!
hasBuildingNamed: aString

	^ buildings anySatisfy: [ :each | each model name = aString ]! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 14:52'!
initialize 
	
	super initialize.
	buildings := OrderedCollection new.! !

!District methodsFor: 'accessing' stamp: 'blo 7/4/2012 15:20'!
printOn: aStream

	city ifNotNil: [ aStream
					nextPutAll: city asString;
					nextPutAll: '-> '].
	name ifNotNil: [ aStream 
					nextPutAll: ' District: '; 
					nextPutAll: self name ].! !

Object subclass: #SourceCityApi
	instanceVariableNames: 'sourceCityImporter cameraXposition cameraYposition cameraZposition backgroundOpenGL buildingGap districtGap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!SourceCityApi commentStamp: '<historical>' prior: 0!
Provides default configuration parameters for Source city GL views. All the default methods provide extension poinits for customizing GL views. If someone wants to describe their own config, default methods can be overriden.!

!SourceCityApi class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/2/2012 14:16'!
default
	^ self new! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:20'!
backgroundOpenGL
	^ backgroundOpenGL! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:20'!
backgroundOpenGL: anObject
	backgroundOpenGL := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:22'!
buildingGap
	^ buildingGap! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:22'!
buildingGap: anObject
	buildingGap := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraXposition
	^ cameraXposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraXposition: anObject
	cameraXposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraYposition
	^ cameraYposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraYposition: anObject
	cameraYposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraZposition
	^ cameraZposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraZposition: anObject
	cameraZposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:23'!
districtGap
	^ districtGap! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:23'!
districtGap: anObject
	districtGap := anObject! !

!SourceCityApi methodsFor: 'initialize-release' stamp: 'DouailleErwan 7/2/2012 14:23'!
initialize
	cameraXposition := -196.
	cameraYposition := -15.
	cameraZposition := 0.
	sourceCityImporter :=  #().
	backgroundOpenGL := Color white.
	buildingGap := 2.
	districtGap := 2.! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:07'!
sourceCityImporter
	^ sourceCityImporter! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:07'!
sourceCityImporter: anObject
	sourceCityImporter := anObject! !

Object subclass: #SourceCityFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 12:33'!
createBuilding: anObject district: aDistrict strategy: aStrategy
	^ Building named: (aStrategy buildingNameGenerator value: anObject)
		inDistrict: aDistrict 
		dimension: (aStrategy normalizedBuildingDimension value: anObject)
		color: (aStrategy normalizedColor value: anObject )
	! !

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 12:59'!
createCity: anObject named: aName strategy: aStrategy
	| districtObjects city id |
	self flag: 'ensureDisctrict'.
	districtObjects := aStrategy districtsSelector value: anObject.
	city := City named: aName.
	districtObjects do: [:district | 
		city add: (self createDistrict: district city: city strategy: aStrategy)
		] displayingProgress: [:aDistrict | 'Build District: ', aDistrict name].
	^city.! !

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'blo 7/4/2012 15:11'!
createDistrict: anObject city: aCity strategy: aStrategy
	| district |
	district := District named: (aStrategy districtNameGenerator value: anObject) inCity: aCity.
	(aStrategy buildingsSelector value: anObject) do: [:building |
		district add: (self createBuilding: building district: district strategy: aStrategy )
		].
	^district
	! !

!Float methodsFor: '*SourceCity-Core' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !
